/**
 * apeman react package for spinner.
 * @class ApSpinner
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _apemanReactMixinPure = require('apeman-react-mixin-pure');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SpinnerThemes = {
  a: ['fa', 'fa-spin', 'fa-spinner'],
  b: ['fa', 'fa-spin', 'fa-circle-o-notch'],
  c: ['fa', 'fa-spin', 'fa-refresh'],
  d: ['fa', 'fa-spin', 'fa-gear'],
  e: ['fa', 'fa-spin', 'fa-pulse']
};
var SpinnerSizes = ['medium', 'xx-small', 'x-small', 'small', 'large', 'x-large', 'xx-large', 'smaller', 'larger'];

var DEFAULT_THEME = 'c';
var DEFAULT_SIZE = 'medium';

/** @lends ApSpinner */
var ApSpinner = _react2.default.createClass({
  displayName: 'ApSpinner',


  // --------------------
  // Specs
  // --------------------
  propTypes: {
    /** Shows spin */
    enabled: _react.PropTypes.bool,
    /** Theme of the spinner */
    theme: _react.PropTypes.oneOf(Object.keys(SpinnerThemes)),
    /** Size of spinner icon */
    size: _react.PropTypes.oneOf(SpinnerSizes),
    /** show as cover */
    cover: _react.PropTypes.bool
  },

  mixins: [_apemanReactMixinPure.ApPureMixin],

  statics: {
    DEFAULT_THEME: DEFAULT_THEME
  },

  getInitialState: function getInitialState() {
    return {};
  },
  getDefaultProps: function getDefaultProps() {
    return {
      enabled: false,
      theme: DEFAULT_THEME,
      size: DEFAULT_SIZE
    };
  },
  render: function render() {
    var s = this;
    var props = s.props;

    var className = (0, _classnames2.default)('ap-spinner', props.className, {
      'ap-spinner-cover': !!props.cover,
      'ap-spinner-enabled': !!props.enabled
    });
    return _react2.default.createElement(
      'div',
      { className: className,
        style: Object.assign({}, props.style) },
      _react2.default.createElement('span', { className: (0, _classnames2.default)('ap-spinner-icon', SpinnerThemes[props.theme]),
        style: { fontSize: props.size }
      })
    );
  },


  // --------------------
  // Lifecycle
  // --------------------

  componentDidMount: function componentDidMount() {
    var s = this;
    s.setState({
      iconVisible: true
    });
  },
  componentWillUnmount: function componentWillUnmount() {
    var s = this;
  }

  // --------------------
  // Custom
  // --------------------

});

exports.default = ApSpinner;
//# sourceMappingURL=data:application/json;base64,bnVsbA==