/**
 * Style for ApSpinner.
 * @class ApSpinnerStyle
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _apemanReactStyle = require('apeman-react-style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** @lends ApSpinnerStyle */
var ApSpinnerStyle = _react2.default.createClass({
  displayName: 'ApSpinnerStyle',

  propTypes: {
    type: _react.PropTypes.string,
    style: _react.PropTypes.object
  },
  getDefaultProps: function getDefaultProps() {
    return {
      type: 'text/css',
      style: {}
    };
  },

  statics: {
    styleData: function styleData(config) {
      return {
        all: {
          '.ap-spinner': {
            textAlign: 'center',
            display: 'none'
          },
          '.ap-spinner.ap-spinner-enabled': {
            display: 'inline-flex',
            justifyContent: 'center',
            alignItems: 'center',
            width: '100%',
            height: '100%'
          },
          '.ap-spinner-icon': {
            display: 'inline-block',
            margin: '0 4px',
            transition: 'opacity 100ms',
            opacity: 1
          },
          '.ap-spinner.ap-spinner-cover': {
            position: 'absolute',
            left: 0,
            top: 0,
            right: 0,
            bottom: 0,
            zIndex: 4,
            display: 'flex',
            justifyContent: 'center',
            alignItems: 'center',
            background: _apemanReactStyle.ApStyle.COVER_BACKGROUND,
            color: _apemanReactStyle.ApStyle.COVER_COLOR
          }
        },
        small: {},
        medium: {},
        large: {}
      };
    }
  },
  render: function render() {
    var s = this;
    var props = s.props;

    var _ApSpinnerStyle$style = ApSpinnerStyle.styleData(props);

    var all = _ApSpinnerStyle$style.all;
    var small = _ApSpinnerStyle$style.small;
    var medium = _ApSpinnerStyle$style.medium;
    var large = _ApSpinnerStyle$style.large;


    return _react2.default.createElement(
      _apemanReactStyle.ApStyle,
      { data: Object.assign(all, props.style),
        smallMediaData: small,
        mediumMediaData: medium,
        largeMediaData: large
      },
      props.children
    );
  }
});

exports.default = ApSpinnerStyle;
//# sourceMappingURL=data:application/json;base64,bnVsbA==